"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _someLoaderUtils = require("@zougt/some-loader-utils");

var _package = _interopRequireDefault(require("../../package.json"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import fs from 'fs';
function HotUpdateLoader(content) {
  const callback = this.async();

  const packRoot = require.resolve(_package.default.name, {
    paths: [this.context || process.cwd()]
  }).replace(/[\\/]cjs\.js$/, '').replace(/\\/g, '/');

  const param = (0, _someLoaderUtils.getPluginParams)();
  const dep = param.customThemeOutputPath || `${packRoot}/hot-loader/setCustomThemeContent.js`;

  if (this.mode === 'development' && this.resourcePath === `${packRoot}/setCustomTheme.js`) {
    // 在开发模式下
    this._compiler.hasZougtUpdateLoader = true;
    this.addDependency(dep);
    this.addDependency(`${packRoot}/setCustomTheme.js`);
    callback(null, `import setCustomTheme from '${dep}';
      export default setCustomTheme;
      import Color from 'color';
      if (module.hot) {
        module.hot.accept('${dep}', function() {
          const moduleId = require.resolve('@setCustomTheme');
          if (require.cache[moduleId]) {
            require.cache[moduleId].hot.invalidate();
          }
          setCustomTheme({Color});
        });
      }
      `);
    return;
  }

  callback(null, content);
}

var _default = HotUpdateLoader;
exports.default = _default;